(define
 (domain towers)
 (:requirements :strips :disjunctive-preconditions)
 (:types OBJ RING - OBJ TOWER - OBJ STACKITEM)
 (:predicates
  (on ?r - RING ?o - OBJ)
  (towerTop ?o - OBJ ?t - TOWER)
  (smallerThan ?r - RING ?o - OBJ)
  (stackTop ?v1 - STACKITEM)
  (counterBegin ?v1 - STACKITEM)
  (counterEnd ?v1 - STACKITEM)
  (counterNext ?v1 - STACKITEM ?v2 - STACKITEM)
  (counterSame ?v1 - STACKITEM ?v2 - STACKITEM)
  (start_shiftTower ?v1 ?v2 ?v3)
  (finished_shiftTower ?v1 ?v2 ?v3)
  (start_selectDirection ?v1 ?v2 ?v3 ?v4)
  (finished_selectDirection ?v1 ?v2 ?v3 ?v4)
  (start_rotateTower ?v1 ?v2 ?v3)
  (finished_rotateTower ?v1 ?v2 ?v3)
  (start_exchange ?v1 ?v2 ?v3)
  (finished_exchange ?v1 ?v2 ?v3)
  (start_move ?v1 ?v2)
  (finished_move ?v1 ?v2)
  (start_rotateTower_working2 ?t1 - TOWER ?t2 - TOWER ?t3 - TOWER)
  (finished_rotateTower_working2 ?t1 - TOWER ?t2 - TOWER ?t3 - TOWER)
  (start_exchangeLR_working2 ?t1 - TOWER ?t2 - TOWER ?t3 - TOWER)
  (finished_exchangeLR_working2 ?t1 - TOWER ?t2 - TOWER ?t3 - TOWER)
  (start_exchangeRL_working2 ?t1 - TOWER ?t2 - TOWER ?t3 - TOWER)
  (finished_exchangeRL_working2 ?t1 - TOWER ?t2 - TOWER ?t3 - TOWER))
  
 (:action shiftTower_d1
  :parameters (?r - RING ?t1 - TOWER ?t2 - TOWER ?t3 - TOWER)
  :precondition
  (and (start_shiftTower ?t1 ?t2 ?t3) (towerTop ?r ?t1))
  :effect
  (and
   (not (start_shiftTower ?t1 ?t2 ?t3))
   (finished_shiftTower ?t1 ?t2 ?t3)
   (start_selectDirection ?r ?t1 ?t2 ?t3)
   (not (finished_selectDirection ?r ?t1 ?t2 ?t3))))
  
 (:action selectedDirection_set1
  :parameters (?r - RING ?t1 - TOWER ?t2 - TOWER ?t3 - TOWER)
  :precondition
  (and (start_selectDirection ?r ?t1 ?t2 ?t3) (on ?r ?t1))
  :effect
  (and
   (not (start_selectDirection ?r ?t1 ?t2 ?t3))
   (finished_selectDirection ?r ?t1 ?t2 ?t3)
   (start_rotateTower ?t1 ?t3 ?t2)
   (not (finished_rotateTower ?t1 ?t3 ?t2))))
  
 (:action selectDirection_find1
  :parameters (?r - RING ?t1 - TOWER ?t2 - TOWER ?t3 - TOWER ?r1 - RING)
  :precondition
  (and (start_selectDirection ?r ?t1 ?t2 ?t3) (on ?r ?r1))
  :effect
  (and
   (not (start_selectDirection ?r ?t1 ?t2 ?t3))
   (finished_selectDirection ?r ?t1 ?t2 ?t3)
   (start_selectDirection ?r1 ?t1 ?t3 ?t2)
   (not (finished_selectDirection ?r1 ?t1 ?t3 ?t2))))
  
 (:action rotateTower_working1
  :parameters (?t1 - TOWER ?t2 - TOWER ?t3 - TOWER)
  :precondition (start_rotateTower ?t1 ?t2 ?t3)
  :effect
  (and
   (not (start_rotateTower ?t1 ?t2 ?t3))
   (finished_rotateTower ?t1 ?t2 ?t3)
   (start_move ?t1 ?t2)
   (not (finished_move ?t1 ?t2))
   (start_rotateTower_working2 ?t1 ?t2 ?t3)
   (not (finished_rotateTower_working2 ?t1 ?t2 ?t3))))
  
 (:action rotateTower_working2
  :parameters (?t1 - TOWER ?t2 - TOWER ?t3 - TOWER)
  :precondition
  (and
   (start_rotateTower_working2 ?t1 ?t2 ?t3)
   (finished_move ?t1 ?t2))
  :effect
  (and
   (not (start_rotateTower_working2 ?t1 ?t2 ?t3))
   (finished_rotateTower_working2 ?t1 ?t2 ?t3)
   (start_exchange ?t1 ?t2 ?t3)
   (not (finished_exchange ?t1 ?t2 ?t3))))
  
 (:action exchangeClear_done1
  :parameters (?t1 - TOWER ?t2 - TOWER ?t3 - TOWER ?v1 - STACKITEM ?v2 - STACKITEM)
  :precondition
  (and
   (start_exchange ?t1 ?t2 ?t3)
   (towerTop ?t1 ?t1)
   (towerTop ?t3 ?t3)
   (stackTop ?v1)
   (counterNext ?v2 ?v1))
  :effect
  (and
   (not (start_exchange ?t1 ?t2 ?t3))
   (finished_exchange ?t1 ?t2 ?t3)
   (not (stackTop ?v1))
   (stackTop ?v2)))
  
 (:action exchangeLR_working1
  :parameters (?t1 - TOWER ?t2 - TOWER ?t3 - TOWER ?r1 - RING ?o3 - OBJ)
  :precondition
  (and
   (start_exchange ?t1 ?t2 ?t3)
   (towerTop ?r1 ?t1)
   (towerTop ?o3 ?t3)
   (smallerThan ?r1 ?o3))
  :effect
  (and
   (not (start_exchange ?t1 ?t2 ?t3))
   (finished_exchange ?t1 ?t2 ?t3)
   (start_move ?t1 ?t3)
   (not (finished_move ?t1 ?t3))
   (start_exchangeLR_working2 ?t1 ?t2 ?t3)
   (not (finished_exchangeLR_working2 ?t1 ?t2 ?t3))))
  
 (:action exchangeLR_working2
  :parameters (?t1 - TOWER ?t2 - TOWER ?t3 - TOWER)
  :precondition
  (and
   (start_exchangeLR_working2 ?t1 ?t2 ?t3)
   (finished_move ?t1 ?t3))
  :effect
  (and
   (not (start_exchangeLR_working2 ?t1 ?t2 ?t3))
   (finished_exchangeLR_working2 ?t1 ?t2 ?t3)
   (start_rotateTower ?t2 ?t3 ?t1)
   (not (finished_rotateTower ?t2 ?t3 ?t1))))
  
 (:action exchangeRL_working1
  :parameters (?t1 - TOWER ?t2 - TOWER ?t3 - TOWER ?o1 - OBJ ?r3 - RING)
  :precondition
  (and
   (start_exchange ?t1 ?t2 ?t3)
   (towerTop ?o1 ?t1)
   (towerTop ?r3 ?t3)
   (smallerThan ?r3 ?o1))
  :effect
  (and
   (not (start_exchange ?t1 ?t2 ?t3))
   (finished_exchange ?t1 ?t2 ?t3)
   (start_move ?t3 ?t1)
   (not (finished_move ?t3 ?t1))
   (start_exchangeRL_working2 ?t1 ?t2 ?t3)
   (not (finished_exchangeRL_working2 ?t1 ?t2 ?t3))))
  
 (:action exchangeRL_working2
  :parameters (?t1 - TOWER ?t2 - TOWER ?t3 - TOWER)
  :precondition
  (and
   (start_exchangeRL_working2 ?t1 ?t2 ?t3)
   (finished_move ?t3 ?t1))
  :effect
  (and
   (not (start_exchangeRL_working2 ?t1 ?t2 ?t3))
   (finished_exchangeRL_working2 ?t1 ?t2 ?t3)
   (start_rotateTower ?t2 ?t3 ?t1)
   (not (finished_rotateTower ?t2 ?t3 ?t1))))
  
 (:action move
  :parameters (?r - RING ?o1 - OBJ ?t1 - TOWER ?o2 - OBJ ?t2 - TOWER)
  :precondition
  (and
   (start_move ?t1 ?t2)
   (towerTop ?r ?t1)
   (towerTop ?o2 ?t2)
   (on ?r ?o1)
   (smallerThan ?r ?o2))
  :effect
  (and
   (not (start_move ?t1 ?t2))
   (finished_move ?t1 ?t2)
   (not (on ?r ?o1))
   (on ?r ?o2)
   (not (towerTop ?r ?t1))
   (towerTop ?o1 ?t1)
   (not (towerTop ?o2 ?t2))
   (towerTop ?r ?t2))))
